; ##############################################################################
; ##############################################################################
; ##############################################################################
LINIE_TEST:
	ldi temp1,0			;X1
	ldi temp2,0			;Y1
	ldi temp3,127		;X2
	ldi temp4,0 		;Y2
	mov X1,temp1
	mov Y1,temp2
	mov X2,temp3
	mov Y2,temp4
	rcall LINIE_X1_Y1_X2_Y2
	rcall OLED_REFRESH
	rcall WAIT_100ms

	ldi temp1,0			;X1
	ldi temp2,0			;Y1
	ldi temp3,0			;X2
	ldi temp4,63 		;Y2
	mov X1,temp1
	mov Y1,temp2
	mov X2,temp3
	mov Y2,temp4
	rcall LINIE_X1_Y1_X2_Y2
	rcall OLED_REFRESH
	rcall WAIT_100ms


	ldi temp1,0			;X1
	ldi temp2,63		;Y1
	ldi temp3,127		;X2
	ldi temp4,63 		;Y2
	mov X1,temp1
	mov Y1,temp2
	mov X2,temp3
	mov Y2,temp4
	rcall LINIE_X1_Y1_X2_Y2
	rcall OLED_REFRESH
	rcall WAIT_100ms

	ldi temp1,127		;X1
	ldi temp2,0			;Y1
	ldi temp3,127		;X2
	ldi temp4,63 		;Y2
	mov X1,temp1
	mov Y1,temp2
	mov X2,temp3
	mov Y2,temp4
	rcall LINIE_X1_Y1_X2_Y2
	rcall OLED_REFRESH
	rcall WAIT_100ms

	ldi temp1,0			;X1
	ldi temp2,0			;Y1
	ldi temp3,127		;X2
	ldi temp4,63 		;Y2
	mov X1,temp1
	mov Y1,temp2
	mov X2,temp3
	mov Y2,temp4
	rcall LINIE_X1_Y1_X2_Y2
	rcall OLED_REFRESH
	rcall WAIT_100ms

	ldi temp1,0			;X1
	ldi temp2,63		;Y1
	ldi temp3,127		;X2
	ldi temp4,0 		;Y2
	mov X1,temp1
	mov Y1,temp2
	mov X2,temp3
	mov Y2,temp4
	rcall LINIE_X1_Y1_X2_Y2
	rcall OLED_REFRESH
	rcall WAIT_100ms

	ldi temp1,127/2		;X1
	ldi temp2,63/2		;Y1
	ldi temp3,127/2-10	;X2
	ldi temp4,63 		;Y2
	mov X1,temp1
	mov Y1,temp2
	mov X2,temp3
	mov Y2,temp4
	rcall LINIE_X1_Y1_X2_Y2
	rcall WAIT_100ms

	ldi temp1,127/2		;X1
	ldi temp2,63/2		;Y1
	ldi temp3,127/2+10	;X2
	ldi temp4,63 		;Y2
	mov X1,temp1
	mov Y1,temp2
	mov X2,temp3
	mov Y2,temp4
	rcall LINIE_X1_Y1_X2_Y2
	rcall OLED_REFRESH
	rcall WAIT_1s

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: SRAM adr_X1																
; 			adr_Y1																
;			adr_X2																
;			adr_Y2																
LINIE_X1_Y1_X2_Y2:
;-------------------------------------------------------------------------------
; Delta-X Delta-Y																
	mov R0,X2		; X2-X1
	sub R0,X1
	STS(adr_DELTA_X),R0
	mov R1,Y2		; Y2-Y1
	sub R1,Y1
	STS(adr_DELTA_Y),R1
;-------------------------------------------------------------------------------
	LDS R0,(adr_DELTA_X)
	tst R0				; positiv ?		
	brpl LINIE_OK		; ja			
	mov R0,X1			;X1 X2 tauschen	
	mov R1,X2
	mov X1,R1
	mov X2,R0

	mov R0,Y1			;Y1 Y2 tauschen	
	mov R1,Y2
	mov Y1,R1
	mov Y2,R0
	rjmp LINIE_X1_Y1_X2_Y2
;-------------------------------------------------------------------------------
LINIE_OK:
	mov XL,X1
	clr XH	
	mov YL,Y1
	clr YH
	rcall PUNKT_SET_XY	; Anfangs-Punkt	
	mov XL,X2
	clr XH	
	mov YL,Y2
	clr YH
	rcall PUNKT_SET_XY	; End-Punkt		
	mov XL,X1			; initialisierung			
	mov YL,Y1
;-------------------------------------------------------------------------------
LINIE_WAAGERECHT:
	LDS temp,(adr_DELTA_Y)			; waagerechte Linie ?
	tst temp
	brne LINIE_SENKRECHT			; nein				
	LDS temp9,(adr_DELTA_X)			; Schleife			
LINIE_s1:							; waagerechte Linie 
	rcall PUNKT_SET_XY
	inc XL
	dec temp9
	brne LINIE_s1
	ret
;-------------------------------------------------------------------------------
LINIE_SENKRECHT:
	LDS temp,(adr_DELTA_X)			; senkrechte Linie ?
	tst temp
	brne LINIE_SR					; nein				
	LDS temp9,(adr_DELTA_Y)			; Schleife			
LINIE_s2:							; senkrechte Linie 	
	rcall PUNKT_SET_XY
	inc YL
	dec temp9
	brne LINIE_s2
	ret
;-------------------------------------------------------------------------------
LINIE_SR:
	LDS temp,(adr_DELTA_Y)	
	tst temp
	brmi LINIE_NEGATIV
;-------------------------------------------------------------------------------
; positiver Anstieg																
	mov XL,X1			
	mov YL,Y1
	ldi temp8,0						; STEP				
	LDS temp9,(adr_DELTA_X)			; X-Schleife		
LINIE_PA_Xs:
	LDS temp1,(adr_DELTA_Y)	
	mul temp8,temp1
	mov temp1,R0
	mov temp2,R1
	LDS temp3,(adr_DELTA_X)
	call DIVISION_16_8
	add temp1,Y1					; Verschiebung Y	
	mov YL,temp1
	rcall PUNKT_SET_XY
	inc temp8						; STEP+1			
	inc XL							; XL+1				
	dec temp9
	brne LINIE_PA_Xs

	mov XL,X1			
	mov YL,Y1
	ldi temp8,0						; STEP				
	LDS temp9,(adr_DELTA_Y)			; Y-Schleife		
LINIE_PA_Ys:
	LDS temp1,(adr_DELTA_X)	
	mul temp8,temp1
	mov temp1,R0
	mov temp2,R1
	LDS temp3,(adr_DELTA_Y)
	call DIVISION_16_8
	add temp1,X1					; Verschiebung X
	mov XL,temp1
	rcall PUNKT_SET_XY
	inc temp8						; STEP+1			
	inc YL							; XL+1				
	dec temp9
	brne LINIE_PA_Ys
	ret
;-------------------------------------------------------------------------------
; negativer Anstieg																
LINIE_NEGATIV:
	mov XL,X1			
	mov YL,Y1
	ldi temp8,0						; STEP				
	LDS temp9,(adr_DELTA_X)			;X-Schleife			
LINIE_NA_Xs:
	LDS temp1,(adr_DELTA_Y)	
	com temp1						; Invertieren		
	inc temp1
	mul temp8,temp1
	mov temp1,R0
	mov temp2,R1
	LDS temp3,(adr_DELTA_X)
	call DIVISION_16_8
	mov R0,Y1						; Verschiebung Y	
	sub R0,temp1
	mov YL,R0
	rcall PUNKT_SET_XY
	inc temp8						; STEP+1			
	inc XL							; XL+1				
	dec temp9
	brne LINIE_NA_Xs

	LDS R0,(adr_DELTA_Y)			; neu berechnen		
	com R0							; Invertieren		
	inc R0
	STS(adr_DELTA_Y),R0

	mov XL,X1			
	mov YL,Y1
	ldi temp8,0						; STEP				
	LDS temp9,(adr_DELTA_Y)			;Y-Schleife			

LINIE_NA_Ys:
	LDS temp1,(adr_DELTA_X)	
	mul temp8,temp1
	mov temp1,R0
	mov temp2,R1
	LDS temp3,(adr_DELTA_Y)
	call DIVISION_16_8
	mov R0,X1						; Verschiebung X	
	add R0,temp1
	mov XL,R0
	rcall PUNKT_SET_XY
	inc temp8						; STEP+1			
	dec YL							; YL-1				
	dec temp9
	brne LINIE_NA_Ys
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DEBUGG_TEMP1:
	call ZAHL_temp1
	call PROGRAMM_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
	mov temp1,temp9
	rjmp DEBUGG_TEMP1
